import { type FloatBuffer } from "@thi.ng/pixel";
import { Pool, type GeoTIFFImage } from "geotiff";
export interface GeoTiffOpts {
    /**
     * Raster channel to extract from image.
     *
     * @defaultValue 0
     */
    channel: number;
    /**
     * Min/max elevation range to configure image pixel format. If omitted, the
     * range will be auto-computed.
     */
    range: [number, number];
    /**
     * Optionally enable geotiff.js worker pool to speed up processing. Disabled
     * by default.
     *
     * @remarks
     * TODO Submit issue to geotiff.js project re: file URL errors in NodeJS
     *
     * If given as number, a worker pool with `n` workers will be created. If
     * `true`, the default number of workers will be used.
     */
    pool: boolean | number | Pool;
}
export declare const readGeoTiff: (src: ArrayBufferView, opts?: Partial<GeoTiffOpts>) => Promise<{
    img: FloatBuffer;
    tiff: GeoTIFFImage;
}>;
//# sourceMappingURL=read.d.ts.map